from Tkinter import *
from ttk import *

class App(Frame):
    def __init__(self, master=None):
        Frame.__init__(self, master, padding=20)
        self.master.title("Keygrabber")
        self.grid()
        self.createWidgets()

        top = self.winfo_toplevel()

        #bind events
        top.bind("<KeyPress>", self.collect_info)
        top.bind("<KeyRelease>", self.show_info)

        self.press = []
        self.keys = ""

    def collect_info(self, ev):
        if not self.press or self.press[-1].keycode != ev.keycode:
            print
            print "type: ", ev.type
            print "char:", ev.char
            print "keysym:", ev.keysym
            print "keycode:", ev.keycode
            self.press.append(ev)

    def show_info(self, ev):
        if self.press:
            txt = ""
            for k in self.press:
                if txt:
                    txt = txt + " + "
                txt = txt + k.keysym

            self.keydata_entry.config(state=NORMAL)
            self.keydata_entry.delete(0, END)
            self.keydata_entry.insert(0, txt)
            self.keydata_entry.config(state=DISABLED)
            self.press = []
            self.keys = txt

    def createWidgets(self):
        row, col = 0, 0
        l = Label(self, text="Press keys:")
        l.grid(row=row, column=col)
        row += 1

        #show stuff about pressed key
        self.keydata_entry = Entry(self, width=40, state=DISABLED)
        self.keydata_entry.grid(row=row, column=col)
        row += 1



if __name__=="__main__":
    app = App()
    app.mainloop()
    print app.keys
