import os
import glob


class ResManager(dict):

    def load_stuff(self, base_path):
        #set paths
        self["base_path"] = base_path
        self["profile_path"] = os.path.join(base_path, "profiles")
        self["template_path"] = os.path.join(base_path, "templates")

        self["data_path"] = os.path.join(base_path, "data")
        self["html_template_path"] = os.path.join(self["data_path"], "html_templates")
        self["stoicon_path"] = os.path.join(self["data_path"], "sto-ions")

        self.update()

    def reload_stuff(self):
        self.load_stuff(self["base_path"])

    def load_icons(self):
        print "Loading icons..."

    def get_files(self, path, startswith="", endswith="", contains=""):
        #returns list of files matching the given parameters
        filelist = [x for x in os.listdir(path)
            if x.startswith(startswith) and x.endswith(endswith) and \
            contains in x]
        return filelist

    def update(self):
        #get profiles
        self["profiles"] = self.get_files(self["profile_path"],
            endswith=".xml")

        #get templates
        self["templates"] = self.get_files(self["template_path"],
            endswith=".xml")

        #get html templates
        self["html_templates"] = self.get_files(self["html_template_path"],
            endswith=".html")

    def load_file(self, filename):
        lines = []
        try:
            f = open(filename)
            lines = f.readlines()
            f.close()
        except Exception, Error:
            msg = "An error occured while opening the file: \n" + str(Error)
            print msg

        msg = "".join(lines)
        return msg

RESMAN = ResManager()


