import os
import time
import tkMessageBox
from ttk import *

from libs.resources import RESMAN
from libs import configcaptainsays
from libs import launcher

try:
    from libs import captainsays
except ImportError:
    print "Could not import speech recognition module."
    captainsays = None


if __name__ == '__main__':
    try:
        path = os.path.abspath(os.path.dirname(__file__))
    except:
        # probably running inside py2exe which doesn't set __file__
        # Thx to http://www.pyweek.org/d/746/ XD
        path = ""
        pass

    done = False
    speechrec = captainsays is not None
    msg = None

    while not done:
        RESMAN.load_stuff(path)
        app = launcher.App(speechrec=speechrec)
        if msg:
            tkMessageBox.showerror(
                title="A mysterious error has occurred.",
                message=msg)
            msg = None

        app.mainloop()
        if not app.next_app:
            done = True
        else:
            cmd, opt = app.next_app
            if cmd=="edit":
                app = configcaptainsays.App(filename=opt)
                app.mainloop()
            elif cmd=="launch" and captainsays:
                msg = captainsays.main(filename=opt)
            else:
                done = True
            cmd = None


